package com.example.beacondemo.Activity;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;

import com.example.beacondemo.R;
import com.minew.beaconplus.sdk.MTCentralManager;
import com.minew.beaconplus.sdk.MTConnectionHandler;
import com.minew.beaconplus.sdk.MTPeripheral;
import com.minew.beaconplus.sdk.enums.TriggerType;
import com.minew.beaconplus.sdk.enums.Version;
import com.minew.beaconplus.sdk.exception.MTException;
import com.minew.beaconplus.sdk.interfaces.SetTriggerListener;
import com.minew.beaconplus.sdk.model.Trigger;

public class DetailActivity extends AppCompatActivity implements View.OnClickListener {

    private MTPeripheral mtPeripheral;

    private MTConnectionHandler mMTConnectionHandler;

    private MTCentralManager mMtCentralManager;

    private View ivBack;

    private TextView tvSet;

    int mCurSlot = 2;

    TextView txt_name,txt_mac,txt_battery,txt_rssi,txt_device,txt_xaxis,txt_yaxis,txt_zaxis;
    String mac,name;
    int battery,rssi;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_detail);

        initView();
        initData();
        initListener();
    }

    private void initView() {
        ivBack = findViewById(R.id.iv_back);
        tvSet = findViewById(R.id.tv_set);

        //txt_battery=findViewById(R.id.txt_battery);
        txt_mac=findViewById(R.id.txt_mac);
        txt_name=findViewById(R.id.txt_name);
        //txt_rssi=findViewById(R.id.txt_rssi);
        txt_device=findViewById(R.id.txt_device);
        txt_xaxis=findViewById(R.id.txt_xaxis);
        txt_yaxis=findViewById(R.id.txt_yaxis);
        txt_zaxis=findViewById(R.id.txt_zaxis);

        Intent intent = getIntent();
        String mac = intent.getStringExtra("mac");
        String name = intent.getStringExtra("name");
        int battery = intent.getIntExtra("battery",0);
        int rssi = intent.getIntExtra("rssi",0);
        String xaxis = intent.getStringExtra("xaxis");
        String yaxis = intent.getStringExtra("yaxis");
        String zaxis = intent.getStringExtra("zaxis");

        txt_mac.setText("Mac Address : "+mac);
        txt_name.setText("Device Name : "+name);
        /*txt_rssi.setText(rssi);
        txt_battery.setText(battery);*/
        txt_xaxis.setText("X axis: " +xaxis);
        txt_yaxis.setText("Y axis: " +yaxis);
        txt_zaxis.setText("Z axis: " +zaxis);
        txt_device.setText("Device in range. ");
        txt_device.setTextColor(Color.BLUE);

    }

    private void initData() {
        mtPeripheral = MainActivity.mtPeripheral;
        mMTConnectionHandler = mtPeripheral.mMTConnectionHandler;
        mMtCentralManager = MTCentralManager.getInstance(this);
    }

    private void initListener() {
        ivBack.setOnClickListener(this);
        tvSet.setOnClickListener(this);
    }

    public void saveTrigger() {
        Version version = this.mMTConnectionHandler.mTConnectionFeature.getVersion();
        if (version.getValue() >= 4) {
            if (this.mMTConnectionHandler.mTConnectionFeature.supportTriggers.size() > 0
                    && this.mMTConnectionHandler.triggers.size() > 0) {
                Trigger trigger = new Trigger();
                trigger.setCurSlot(mCurSlot);
                boolean isOpen = true;
                if (isOpen) {
                    TriggerType triggerType = TriggerType.BTN_DTAP_EVT;
                    trigger.setTriggerType(TriggerType.BTN_DTAP_EVT);
                    switch (triggerType) {
                        case TEMPERATURE_ABOVE_ALARM:
                        case TEMPERATURE_BELOW_ALARM:
                        case HUMIDITY_ABOVE_ALRM:
                        case HUMIDITY_BELOW_ALRM:
                        case LIGHT_ABOVE_ALRM:
                        case LIGHT_BELOW_ALARM:
                        case FORCE_ABOVE_ALRM:
                        case FORCE_BELOW_ALRM:
                        case TVOC_ABOVE_ALARM:
                        case TVOC_BELOW_ALARM:
                            trigger.setCondition(10);
                            break;
                        default:
                            trigger.setCondition(10 * 1000);
                    }
                } else {
                    trigger.setTriggerType(TriggerType.TRIGGER_SRC_NONE);
                    trigger.setCondition(0);
                }
                if (version.getValue() > 4) {
                    trigger.setAdvInterval(2000);
                    trigger.setRadioTxpower(0);
                    trigger.setAlwaysAdvertising(false);
                }
                this.mMTConnectionHandler.setTriggerCondition(trigger, new SetTriggerListener() {
                    @Override
                    public void onSetTrigger(boolean success, MTException mtException) {
                        //Monitor whether the write is successful
                        Log.e("minew_tag","trigger success " + success);
                    }
                });
            }
        }
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.iv_back:
                mMtCentralManager.disconnect(mtPeripheral);
                finish();
                break;
            case R.id.tv_set:
                saveTrigger();
                break;
            default:
                break;
        }

    }


}